{
* TGrep 1.0 beta
* 
* Author:
*   Gabriele Carioli 
*   Viale Antonio Gramsci, 102
*   47100 Forl (FO) - ITALY
*   E-mail: bilo@lingue.unibo.it
* 
* Copyright  1997-98 by Gabriele Carioli <bilo@lingue.unibo.it>
* 
* This software is provided as it is, without any kind of warranty
* given. Use it at your own risk.
* 
* You may use this software in any kind of development, including
* comercial, redistribute, and modify it freely, under the 
* following restrictions :
* 
* 1. The origin of this software may not be mispresented, you must
*    not claim that you wrote the original software. If you use
*    this software in any kind of product, it would be appreciated
*    that there in a information box, or in the documentation would
*    be an acknowledgmnent like this
*           Parts Copyright  1998 by Gabriele Carioli
* 
* 2. You may not have any income from distributing this source
*    to other developers. When you use this product in a comercial
*    package, the source may not be charged seperatly.
* 
* 3. This notice should also follow the package if you use this
*    component in a commercial product.
}

unit RegExpForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Grep;

type
  TRegExpEditor = class(TForm)
    lblRegExp: TLabel;
    txtRegExp: TEdit;
    btnOK: TBitBtn;
    btnCancel: TBitBtn;
    btnDot: TSpeedButton;
    btnQM: TSpeedButton;
    brnPlus: TSpeedButton;
    btnStar: TSpeedButton;
    btnOR: TSpeedButton;
    btnRB: TSpeedButton;
    btnSB: TSpeedButton;
    btnDash: TSpeedButton;
    btnAccent2: TSpeedButton;
    btnAccent: TSpeedButton;
    btnDollar: TSpeedButton;
    btnInteger: TSpeedButton;
    btnReal: TSpeedButton;
    btnAddr: TSpeedButton;
    btnTCPAddr: TSpeedButton;
    btnID: TSpeedButton;
    btnSelectAll: TBitBtn;
    btnTAB: TSpeedButton;
    btnClear: TBitBtn;
    Grep: TGrep;
    procedure btnCancelClick(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure btnDotClick(Sender: TObject);
    procedure btnStarClick(Sender: TObject);
    procedure brnPlusClick(Sender: TObject);
    procedure btnQMClick(Sender: TObject);
    procedure btnRBClick(Sender: TObject);
    procedure btnAccentClick(Sender: TObject);
    procedure btnDollarClick(Sender: TObject);
    procedure btnORClick(Sender: TObject);
    procedure btnSBClick(Sender: TObject);
    procedure btnDashClick(Sender: TObject);
    procedure btnAccent2Click(Sender: TObject);
    procedure btnIntegerClick(Sender: TObject);
    procedure btnRealClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnAddrClick(Sender: TObject);
    procedure btnTCPAddrClick(Sender: TObject);
    procedure btnIDClick(Sender: TObject);
    procedure btnSelectAllClick(Sender: TObject);
    procedure btnTABClick(Sender: TObject);
    procedure btnClearClick(Sender: TObject);
  private
    { Private declarations }
    procedure AddRegExp(re: string);
  public
    { Public declarations }
  end;

var
  RegExpEditor: TRegExpEditor;

implementation

{$R *.DFM}

procedure TRegExpEditor.btnCancelClick(Sender: TObject);
begin
  Close;
end;

procedure TRegExpEditor.FormCreate(Sender: TObject);
begin
  txtRegExp.SelectAll;
end;

procedure TRegExpEditor.btnClearClick(Sender: TObject);
begin
  txtRegExp.SetFocus;
  txtRegExp.Clear;
end;

procedure TRegExpEditor.btnOKClick(Sender: TObject);
begin
  try
    Grep.RegExp := txtRegExp.Text;
    ModalResult := mrOk;
  except
    on E: Exception do begin
      Beep;
      MessageDlg(E.Message, mtError, [mbOk], 0);
      ModalResult := mrNone;
      txtRegExp.SetFocus;
    end;
  end;
end;

procedure TRegExpEditor.AddRegExp(re: string);
begin
  with txtRegExp do begin
//  if SelText = '' then Text := Text + re else SelText := re;
    SelText := re;
//  Perform(WM_KEYDOWN, VK_END, $0001);
  end;
end;

procedure TRegExpEditor.btnSelectAllClick(Sender: TObject);
begin
  txtRegExp.SetFocus;
  txtRegExp.SelectAll
end;

procedure TRegExpEditor.btnDotClick(Sender: TObject);
begin
  AddRegExp('.');
end;

procedure TRegExpEditor.btnStarClick(Sender: TObject);
begin
  AddRegExp('*');
end;

procedure TRegExpEditor.brnPlusClick(Sender: TObject);
begin
  AddRegExp('+');
end;

procedure TRegExpEditor.btnQMClick(Sender: TObject);
begin
  AddRegExp('?');
end;

procedure TRegExpEditor.btnRBClick(Sender: TObject);
begin
  AddRegExp('()');
end;

procedure TRegExpEditor.btnAccentClick(Sender: TObject);
begin
  AddRegExp('^');
end;

procedure TRegExpEditor.btnDollarClick(Sender: TObject);
begin
  AddRegExp('$');
end;

procedure TRegExpEditor.btnORClick(Sender: TObject);
begin
  AddRegExp('|');
end;

procedure TRegExpEditor.btnSBClick(Sender: TObject);
begin
  AddRegExp('[]');
end;

procedure TRegExpEditor.btnDashClick(Sender: TObject);
begin
  AddRegExp('-');
end;

procedure TRegExpEditor.btnAccent2Click(Sender: TObject);
begin
  AddRegExp('^');
end;

procedure TRegExpEditor.btnIntegerClick(Sender: TObject);
begin
  AddRegExp('\?-[0-9]+');
end;

procedure TRegExpEditor.btnRealClick(Sender: TObject);
begin
  AddRegExp('\-?[0-9]+(\.[0-9]+)?([eE][+\-]?[0-9]+)?');
end;

procedure TRegExpEditor.btnAddrClick(Sender: TObject);
begin
  AddRegExp(cMailAddr);
end;

procedure TRegExpEditor.btnTCPAddrClick(Sender: TObject);
begin
  AddRegExp(cTCPAddr);
end;

procedure TRegExpEditor.btnIDClick(Sender: TObject);
begin
  AddRegExp('[a-zA-Z0-9_]+');
end;

procedure TRegExpEditor.btnTABClick(Sender: TObject);
begin
  AddRegExp(chr(9));
end;

//cTCPAddr  = '[_a-zA-Z0-9\-]+(\.[_a-zA-Z0-9\-]+)+';
//cMailAddr = '([_a-zA-Z0-9\-\.]+)@(' + cTCPAddr + ')';
//cUnixPath = '(/[ _a-zA-Z0-9\-\\\.]+)+';
//cURL      = '([Ff][Tt][Pp]|[Hh][Tt][Tt][Pp])://(' + cTCPAddr + ')(' + cUnixPath + ')';


end.

